package ch.zhaw.prog2.functional.streaming.finance;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.mockito.Mock;

import java.util.ArrayList;
import java.util.Currency;
import java.util.List;
import java.util.stream.Stream;

import static java.util.Currency.getInstance;
import static org.junit.jupiter.api.Assertions.*;
import static org.mockito.Mockito.*;

/**
 * This test class is for all test methods written by students for easier review by lecturers.
 * In a real application these test would be in the class PayrollCreatorTest.
 *
 * ✅  This class should be worked on by students.
 */
class PayrollCreatorTestStudent {
    Payroll payroll;

    @BeforeEach
    void setup(){
        payroll = new Payroll();
    }

    @Test
    void payrollAmountByCurrency() {

        Payroll payroll = mock(Payroll.class);

        List<Payment> payments = new ArrayList<>();
        for(int i = 0; i < 3; i++){
            payments.add(mock(Payment.class));
        }

        List<CurrencyAmount> currencyAmounts = new ArrayList<>();
        for(int i = 0; i < 3; i++){
            currencyAmounts.add(mock(CurrencyAmount.class));
            when(payments.get(i).getCurrencyAmount()).thenReturn(currencyAmounts.get(i));
        }

        when(payroll.stream()).thenReturn(payments.stream());

        when(currencyAmounts.get(0).getCurrency()).thenReturn(getInstance("CHF"));
        when(currencyAmounts.get(0).getAmount()).thenReturn(10);

        when(currencyAmounts.get(1).getCurrency()).thenReturn(getInstance("CHF"));
        when(currencyAmounts.get(1).getAmount()).thenReturn(15);

        when(currencyAmounts.get(2).getCurrency()).thenReturn(getInstance("USD"));
        when(currencyAmounts.get(2).getAmount()).thenReturn(117);

        List<CurrencyAmount> sumCurrencyAmounts = PayrollCreator.payrollAmountByCurrency(payroll);
        assertEquals(25, sumCurrencyAmounts.stream().filter(currencyAmount -> currencyAmount.getCurrency().equals(getInstance("CHF"))).findFirst().get().getAmount());
        assertEquals(117, sumCurrencyAmounts.stream().filter(currencyAmount -> currencyAmount.getCurrency().equals(getInstance("USD"))).findFirst().get().getAmount());

    }
}
